//
// Weekly Separator.mq4
//

#property copyright "2019, getYourNet.ch"
#property link "getYourNet.ch"
#property version "1.0"

#property indicator_chart_window
extern int BarsToProcess=5;
extern color LineColor=DeepSkyBlue;

string namespace="WeeklySeparator";
bool GetTimeError;


void OnDeinit(const int reason)
{
   ObjectsDeleteAll(0,namespace);
}


int OnCalculate(const int rates_total, 
                const int prev_calculated, 
                const datetime& time[], 
                const double& open[], 
                const double& high[], 
                const double& low[], 
                const double& close[], 
                const long& tick_volume[], 
                const long& volume[], 
                const int& spread[]) 
{
   if(prev_calculated<rates_total || GetTimeError)
   {
      GetTimeError=false;

      for(int i=0; i<BarsToProcess; i++)
      {
         datetime t=iTime(NULL,PERIOD_W1,i);
         if(t>0)
         {
            string oname=namespace+"Line "+IntegerToString(i);
            if(ObjectCreate(oname,OBJ_VLINE,0,t,0))
            {
               ObjectSet(oname,OBJPROP_STYLE,STYLE_SOLID);
               ObjectSet(oname,OBJPROP_COLOR,LineColor);
               ObjectSet(oname,OBJPROP_WIDTH,1);
               ObjectSet(oname,OBJPROP_BACK,true);
            }
         }
         else
            GetTimeError=true;
      }
   }

   return rates_total;
}
